# coding: utf-8

"""
    Infobip Client API Libraries OpenAPI Specification

    OpenAPI specification containing public endpoints supported in client API libraries.

    The version of the OpenAPI document: 1.0.0
    Contact: support@infobip.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self


class CallTransfer(BaseModel):
    """
    Call transfers object enables transferring the ongoing call to another recipient(s) and establish a communication between your original recipient and additional one.
    """  # noqa: E501

    call_transfer_max_duration: Optional[StrictInt] = Field(
        default=None,
        description="Maximum duration of the transferred call, specified in seconds.",
        alias="callTransferMaxDuration",
    )
    equals: Optional[StrictStr] = Field(
        default=None,
        description="Criteria for establishing call transfer, if `dtmf` is evaluated.",
    )
    transfer_to: StrictStr = Field(
        description="Phone number of the recipient that will receive transferred call. Must be written in E.164 standard (Example: 41793026727).",
        alias="transferTo",
    )
    var_if: StrictStr = Field(
        description="Specifies what to evaluate. Can be `dtmf` or `anyDtmf`.",
        alias="if",
    )
    __properties: ClassVar[List[str]] = [
        "callTransferMaxDuration",
        "equals",
        "transferTo",
        "if",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CallTransfer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CallTransfer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "callTransferMaxDuration": obj.get("callTransferMaxDuration"),
                "equals": obj.get("equals"),
                "transferTo": obj.get("transferTo"),
                "if": obj.get("if"),
            }
        )
        return _obj
