# coding: utf-8

"""
    Infobip Client API Libraries OpenAPI Specification

    OpenAPI specification containing public endpoints supported in client API libraries.

    The version of the OpenAPI document: 1.0.0
    Contact: support@infobip.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from infobip_api_client.models.calls_public_country import CallsPublicCountry
from infobip_api_client.models.calls_public_region import CallsPublicRegion
from typing import Optional, Set
from typing_extensions import Self


class CallsPublicSipTrunkServiceAddress(BaseModel):
    """
    CallsPublicSipTrunkServiceAddress
    """  # noqa: E501

    id: Optional[StrictStr] = Field(
        default=None, description="SIP trunk service address ID."
    )
    name: Optional[StrictStr] = Field(
        default=None, description="SIP trunk service address name."
    )
    street: Optional[StrictStr] = Field(
        default=None, description="SIP trunk service address street."
    )
    city: Optional[StrictStr] = Field(
        default=None, description="SIP trunk service address city."
    )
    post_code: Optional[StrictStr] = Field(
        default=None,
        description="SIP trunk service address post code.",
        alias="postCode",
    )
    suite: Optional[StrictStr] = Field(
        default=None, description="SIP trunk service address suite."
    )
    country: Optional[CallsPublicCountry] = None
    region: Optional[CallsPublicRegion] = None
    __properties: ClassVar[List[str]] = [
        "id",
        "name",
        "street",
        "city",
        "postCode",
        "suite",
        "country",
        "region",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CallsPublicSipTrunkServiceAddress from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of country
        if self.country:
            _dict["country"] = self.country.to_dict()
        # override the default output from pydantic by calling `to_dict()` of region
        if self.region:
            _dict["region"] = self.region.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CallsPublicSipTrunkServiceAddress from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "name": obj.get("name"),
                "street": obj.get("street"),
                "city": obj.get("city"),
                "postCode": obj.get("postCode"),
                "suite": obj.get("suite"),
                "country": CallsPublicCountry.from_dict(obj["country"])
                if obj.get("country") is not None
                else None,
                "region": CallsPublicRegion.from_dict(obj["region"])
                if obj.get("region") is not None
                else None,
            }
        )
        return _obj
